
package de.ivu.elect.presentation.gebietsbaum;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungBoundaryCreate;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.gebietsbaum.entity.GebietsgruppierungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractGebietsgruppierungCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractGebietsgruppierungCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.GEBIETSGRUPPIERUNG_CREATE)
public abstract class AbstractGebietsgruppierungCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Gebietsgruppierung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsgruppierungCreateView";

  public static final String VIEW_ID = "/gebietsbaum/gebietsgruppierung-create.xhtml";

  public static final String PARENT_VIEW_ID = "/gebietsbaum/gebietsgruppierung-search.xhtml";

  @Inject
  protected transient GebietsgruppierungBoundaryCreate create;

  protected Gebietsgruppierung entity;

  @Inject
  protected transient GebietsgruppierungMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Gebietsgruppierung());
  }

  

  public Gebietsgruppierung getEntity() {
    return entity;
  }

  protected void setEntity(Gebietsgruppierung entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.GEBIETSGRUPPIERUNG_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Gebietsgruppierung entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Gebietsgruppierung entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.GEBIETSGRUPPIERUNG_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
